
BLAST	; repeat mem/io read or write command until period or ESC
	CALL	GETUCHE			; get a	char and echo
	CP	'I'			; see if blast input wanted
	JR	NZ,BLAST10		; jump if not
	JP	BLSTI			; do the routine
BLAST10	CP	'O'			; see if blast output wanted
	JR	NZ,BLAST20		; jump if not
	JP	BLSTO			; do the routine
BLAST20	CP	'F'			; see if blast from wanted
	JR	NZ,BLAST30		; jump if not
	JP	BLSTF			; do the routine
BLAST30	CP	'T'			; see if blast to wanted
	JR	NZ,BLAST40		; jump if not
	JP	BLSTT			; do the routine
BLAST40	JP	CMDNOP			; else, bad command

BLSTI	;  bi addr,  blast input from port "addr"
	;  repeat until period or ESC
	CALL	SPACE1
	CALL	CARG			; collect args
	CALL	CRLF			; output on new line
	LD	A,(ARGC)		; get count
	CP	1
	JP	NZ,ARGERR		; error	if not just one	argument
BLSTI10	LD	BC,(ARGV0)		; get port address
	IN	A,(C)			; get data
	PUSH	AF			; save data on stack
	CALL	PBIN			; print	it
	CALL	SPACE1			; print a space
	POP	AF			; restore data
	CALL	PHXBYTE			; print as hex byte
	CALL	CRLF			; newline
	LD	HL,10000		; get delay value
BLSTI20	IN	A,(C)			; get data, but ignore value
	CALL	KBPESC			; period or ESC from KB?
	JR	C,BLSTI30		; stop if so
	DEC	HL			; dec the counter
	LD	A,H			; get high to A
	OR	L			; or in low value
	JR	NZ,BLSTI20		; loop if not zero
	JR	BLSTI10			; do again but print result
BLSTI30	RET

BLSTO	;  bo addr data,  blast "data" to port "addr"
	;  repeat until period or ESC
	CALL	SPACE1			; space
	CALL	CARG			; collect arguments
	CALL	CRLF			; newline
	LD	A,(ARGC)		; get number of args
	CP	2			; should always be 2
	JP	NZ,ARGERR		; check	for arg	errors
BLSTO10	LD	BC,(ARGV0)		; get port to C
	LD	DE,(ARGV1)		; get data to E
	LD	A,E			; get data to A
	OUT	(C),A			; output the data
	CALL	KBPESC			; period or ESC from KB?
	JR	NC,BLSTO10		; stop if so
	RET

BLSTF	;  bf addr,  blast from memory "addr"
	;  repeat until period or ESC
	CALL	SPACE1
	CALL	CARG			; collect args
	CALL	CRLF			; output on new line
	LD	A,(ARGC)		; get count
	CP	1
	JP	NZ,ARGERR		; error	if not just one	argument
BLSTF10	LD	BC,(ARGV0)		; get memory address
	LD	A,(BC)			; get data
	PUSH	AF			; save data on stack
	CALL	PBIN			; print	it
	CALL	SPACE1			; print a space
	POP	AF			; restore data
	CALL	PHXBYTE			; print as hex byte
	CALL	CRLF			; newline
	LD	HL,10000		; get delay value
BLSTF20	LD	A,(BC)			; get data, but ignore value
	CALL	KBPESC			; period or ESC from KB?
	JR	C,BLSTF30		; stop if so
	DEC	HL			; dec the counter
	LD	A,H			; get high to A
	OR	L			; or in low value
	JR	NZ,BLSTF20		; loop if not zero
	JR	BLSTF10			; do again but print result
BLSTF30	RET

BLSTT	;  bt addr data,  blast "data" to memory "addr"
	;  repeat until period or ESC
	CALL	SPACE1			; space
	CALL	CARG			; collect arguments
	CALL	CRLF			; newline
	LD	A,(ARGC)		; get number of args
	CP	2			; should always be 2
	JP	NZ,ARGERR		; check	for arg	errors
BLSTT10	LD	BC,(ARGV0)		; get memory adr to BC
	LD	DE,(ARGV1)		; get data to E
	LD	A,E			; get data to A
	LD	(BC),A			; save the data
	CALL	KBPESC			; period or ESC from KB?
	JR	NC,BLSTT10		; stop if so
	RET

CHECK	; calc sum and sum+1 over ARGV0 through ARGV1
	; print sum and sum+1 on console
	; usage: c start end
	CALL	SPACE1			; space	over one
	CALL	CARG			; collect args
	CALL	CRLF			; output on new line
	LD	A,(ARGC)		; get the count
	CP	2
	JP	NZ,ARGERR		; error	if not 2
	LD	IY,(ARGV0)		; start
	PUSH	IY
	POP	BC			; start	in BC too
	LD	HL,(ARGV1)		; and end
	OR	A			; clear	CY
	SBC	HL,BC			; calc range (do that amount)
	INC	HL			; make it inclusive
	PUSH	HL			; save range on stack
	PUSH	HL			; and move
	POP	BC			; to BC
	LD	HL,0			; zero accumulator
	LD	D,0			; D is zero
CHECK10	LD	E,(IY+0)		; get a	byte
	ADD	HL,DE			; to 16	bit add
	INC	IY			; pt++
	DEC	BC			; ctr--
	LD	A,C			; test
	OR	B			; for
	JR	NZ,CHECK10		; count	== 0, loop till	so
	CALL	SPACE2			; space over 2
	CALL	PHL			; print sum
	POP	DE			; get range
	ADD	HL,DE			; add range
	CALL	SPACE2			; space over 2
	CALL	PHL			; print sum+1
	CALL	CRLF			; new line
	RET

DISPLAY	;  display memory
	;  usage: d start stop
	CALL	SPACE1
	CALL	CARG			; collect arguments
	LD	A,(ARGC)		; get count
	CP	2
	JR	Z,DISPL05		; do it
	CP	1
	JP	NZ,ARGERR		; error	if not 2
	LD	HL,(ARGV0)		; use only
	LD	(ARGV1),HL		; one argument
DISPL05	LD	HL,ARGV0		; get start
	LD	A,(HL)
	AND	0F0H
	LD	(HL),A			; insure an 16 byte boundary
	INC	HL
	INC	HL
	LD	A,(HL)
	OR	0FH
	LD	(HL),A			; same for sp/8	- 1
DISPL10	CALL	PLINE			; print	a line
	LD	DE,2			; get value for 200 mS delay
	CALL	DELAY			; do small delay for terminal
	CALL	KBPESC			; period or ESC from KB?
	JR	C,DISPL20		; stop if so
	CALL	V01GT			; v0 >=	v1?
	JR	NC,DISPL10		; jump if not
DISPL20	CALL	CRLF			; finish with a	newline
	RET

FIND	;  find	the arg	list wherever it appears in memory
	;  usage: f arg0 <arg1>	<arg2> ... <arg15> (16 max)
	CALL	SPACE1
	LD	C,0			; C is arg count
	LD	DE,FBUF			; DE is	buffer pointer
FIND10	CALL	GARG			; get an arg
	JR	Z,FIND20		; finished if no input
	PUSH	AF			; save CY flag
	LD	A,L
	LD	(DE),A			; save LSB
	INC	DE			; point	to next	location
	INC	C			; inc arg counter
	POP	AF			; restore CY
	JR	C,FIND20		; jump if CR entered
	LD	A,C			; get count
	CP	16
	JR	NZ,FIND10		; jump if not terminal count
FIND20	CALL	CRLF			; put it on a new line
	LD	A,C			; get count
	OR	A			; test for no input
	RET	Z			; return if so
	LD	DE,0			; else continue	and zero pointer
FIND30	LD	HL,FBUF			; HL points to buffer
	LD	A,E			; get E
	AND	D			; and with D
	CPL	A			; all zero if de == 0xffff
	OR	A			; set flags
	RET	Z			; ret if main mem pointer is 0xffff
	CALL	KBPESC			; period or ESC RXed?
	RET	C			; stop if so
	LD	A,(DE)			; get a	char
	CP	(HL)			; test with array
	JR	Z,FIND40		; jump if they match
	INC	DE			; else inc main	memory pointer
	JR	FIND30			; else continue
FIND40	PUSH	DE			; found	a possible match
	LD	B,C			; get arg count
	LD	(ARGV0),DE		; save main mem	pointer	in ARGV0
FIND50	LD	A,(DE)			; get a	main mem char
	CP	(HL)			; compare with arg list
	INC	DE			; inc both pointers
	INC	HL
	JR	NZ,FIND60		; jump if chars	didn't match
	DJNZ	FIND50			; loop till all	chars are matched
	LD	A,E			; skip if same ptr as FBUF
	CP	L			; see if LSbytes are same
	JR	NZ,FIND55		; jump if not
	LD	A,D			; see if MSbytes are same
	CP	H
	JR	NZ,FIND55		; jump if not
	JR	FIND60			; match was with arg list itself!
FIND55	CALL	PADDR			; print	the address
	CALL	CRLF			; newline
	LD	HL,200H			; get 6.5*512 micro-sec
	CALL	KILTIME			; wait for terminal
FIND60	POP	DE			; restore main mem pointer
	INC	DE			; inc it
	JP	FIND30			; continue till	end of memory

GO	;  go and return with breakpoints
	;  useage: g<start> <bp1> <bp2>
	RES	BP00,(IX+S0)
	RES	BP10,(IX+S0)		; no BKPOINTs yet
	CALL	ZARG			; zero the arg memory
	CALL	GARGNSP			; get one arg no space allowed
	JR	Z,GO10			; jump if no input
	LD	(PLLOC),HL		; get arg
GO10	JR	C,GO30			; jump if return was entered
	CALL	CARG			; get arg line
	LD	A,(ARGC)		; get number of	bkpoints
	OR	A
	JR	Z,GO30			; jump if none
	CP	1
	JR	Z,GO20			; jump if only 1
	LD	HL,(ARGV1)		; get 2nd bkpoint
	LD	A,(HL)			; get opcode
	LD	(BPOC1),A		; save it
	LD	(BPAD1),HL		; save address
	LD	(HL),BPTRAP		; load a trap
	SET	BP10,(IX+S0)		; set 2nd bkpoint flag
	LD	HL,BPMN			; get magic #
	LD	(BPMNS),HL		; put at storage location
GO20	LD	HL,(ARGV0)		; get 1st bkpoint
	LD	A,(HL)			; get opcode
	LD	(BPOC0),A		; save it
	LD	(BPAD0),HL		; save address
	LD	(HL),BPTRAP		; load a trap
	SET	BP00,(IX+S0)		; set 1st bkpoint flag
	LD	HL,BPMN			; get magic #
	LD	(BPMNS),HL		; put at storage location
GO30	LD	A,(ILOC)
	LD	I,A			; restore I
	LD	A,(RLOC)
	LD	R,A			; restore R
	LD	HL,(APLOC)
	PUSH	HL
	POP	AF
	EX	AF,AF'			; restore AF'
	LD	BC,(CPLOC)
	LD	DE,(EPLOC)
	LD	HL,(LPLOC)
	EXX				; restore BC' DE' HL'
	LD	IX,(XLLOC)		; restore IX
	LD	IY,(YLLOC)		; restore IY
	LD	BC,(CLOC)		; restore BC
	LD	DE,(ELOC)		; restore DE
	LD	HL,(FLOC)		; get AF
	PUSH	HL			; save on stack
	POP	AF			; restore from stack
	LD	HL,(PLLOC)		; get PC
	LD	SP,(SLLOC)		; restore SP
	PUSH	HL			; push PC on stack
	LD	HL,(LLOC)		; restore HL
	RET				; indirect goto	PC (on stack)

HEXMATH	;  calculate sum and difference
	;  usage: h <arg1> <arg2> , sum	diff
	CALL	SPACE1			; space
	CALL	CARG			; collect arguments
	CALL	CRLF			; output on new line
	LD	A,(ARGC)
	CP	2
	JP	NZ,ARGERR		; error	if wrong number	of args
	LD	HL,(ARGV0)		; get first
	LD	BC,(ARGV1)		; and second
	PUSH	HL			; save 
	PUSH	BC
	ADD	HL,BC			; add w/o carry
	CALL	PHL			; print	HL
	CALL	SPACE1			; and space
	POP	BC			; recover them
	POP	HL
	OR	A			; CY = 0
	SBC	HL,BC			; HL <-	HL - BC
	CALL	PHL			; print	HL
	CALL	CRLF			; newline
	RET

INPUT	;  input a byte	from the port; if no argument is given
	;  the last port accessed using	the input command will
	;  be used.
	;  usage: i <port>
	CALL	SPACE1
	CALL	CARG			; collect args
	CALL	CRLF			; output on new line
	JR	NZ,INPUT10		; jump if input
	LD	A,(LSTPORT)		; else,	use last port addressed
	LD	C,A			; put in C
	JR	INPUT20
INPUT10	LD	A,(ARGC)		; get count
	CP	1
	JP	NZ,ARGERR		; error	if not just one	input
	LD	BC,(ARGV0)		; get port
INPUT20	IN	A,(C)			; get data
	PUSH	AF			; save data on stack
	CALL	PBIN			; print	it
	CALL	SPACE1			; print a space
	POP	AF			; restore data
	CALL	PHXBYTE			; print as hex byte
	LD	A,C
	LD	(LSTPORT),A		; save port
	CALL	CRLF
	RET

JAM	;  fill data from START to END (inclusive) with VALUE
	;  usage: j START END VALUE
	CALL	SPACE1			; space
	CALL	CARG			; collect arguments
	LD	A,(ARGC)
	CP	3
	JP	NZ,ARGERR		; jump if wrong	number of args
	LD	HL,(ARGV1)		; get end
	INC	HL			; add one to it
	LD	DE,(ARGV0)		; get begin
	OR	A			; CY = 0
	SBC	HL,DE			; get the difference
	EX	DE,HL			; DE gets # of jams, HL gets start
	LD	A,(ARGV2)		; get VALUE
	LD	B,A			; save in B
JAM10	LD	(HL),B			; jam the data
	INC	HL			; pt to next
	DEC	DE			; dec the ctr
	LD	A,D			; get MS byte
	OR	E			; or with LS byte
	JR	NZ,JAM10		; loop till no more
	CALL	CRLF			; newline
	RET

LSTACK	; list the user	stack onto the screen
	LD	HL,LSKMSG0		; list stack header msg 0
	CALL	PUTS			; print	the string
	LD	HL,(SLLOC)		; get ptr to user stack
	PUSH	HL			; save on stack
	CALL	PHL			; print HL as hex
	LD	HL,LSKMSG1		; list stack header msg 1
	CALL	PUTS			; print	the string
	POP	HL			; restore data from stack
	LD	DE,10			; get offset
	OR	A			; CY = 0
	SBC	HL,DE			; ptr -	10
	LD	B,15			; loop 15 times
LSTAC10	PUSH	HL			; save ptr
	CALL	HLATHL			; get value pointed at
	CALL	PHL			; and print it
	CALL	SPACE1			; followed by a	space
	POP	HL			; restore ptr
	INC	HL			; next
	INC	HL			; next word
	DJNZ	LSTAC10			; loop till B == 0
	CALL	CRLF			; end with a newline
	RET

MOVE	;  move	data from BEGIN	and END	(inclusive) to WHERE
	;  usage: m begin end where
	CALL	SPACE1			; space
	CALL	CARG			; collect arguments
	LD	A,(ARGC)
	CP	3
	JP	NZ,ARGERR		; jump if wrong	number of args
	LD	HL,(ARGV1)		; get end
	INC	HL			; add one to it
	LD	DE,(ARGV0)		; get begin
	OR	A			; CY = 0
	SBC	HL,DE			; get the difference
	PUSH	HL
	POP	BC			; move to BC
	LD	HL,(ARGV0)		; point	to begin
	LD	DE,(ARGV2)		; point	to where
	LDIR				; move them
	CALL	CRLF			; newline
	RET

NEXT	;  do next instruction and display registers
	;  usage: n
	LD	HL,(PLLOC)		; HL gets user PC
	LD	E,(HL)			; get the opcode
	LD	D,0			; in DE
	PUSH	DE
	POP	HL			; copy into HL
	ADD	HL,DE			; multiply by 2
	LD	DE,OCTBAS		; pont to base of bkpoint routines
	ADD	HL,DE			; add em
	CALL	HLATHL			; get address of routine
	JP	(HL)			; jump to it

OUTPUT	;  put a byte to the port
	;  o port data
	CALL	SPACE1			; space
	CALL	CARG			; collect arguments
	LD	A,(ARGC)
	CP	2
	JP	NZ,ARGERR		; check	for arg	errors
	LD	BC,(ARGV0)		; get port to C
	LD	DE,(ARGV1)		; get data to E
	LD	A,E
	OUT	(C),A			; output
	CALL	CRLF			; newline
	RET

RX	;  receive intel hex code
	;  usage: r <offset>
	CALL	GARG			; get offset, do it fast
	LD	(ARGV0),HL		; save it at ARGV0
	CALL	DUMPBP			; dump any outstanding break pts
RX10	CALL	RLINE			; get one record
	JR	NZ,RX10			; if not zero get another
	RET

SUBST	;  substitute memory;  use space for next, CR to end
	;  usage: s address
	CALL	SPACE1
	CALL	CARG			; get arguments
	LD	A,(ARGC)		; get count
	CP	1
	JP	NZ,ARGERR		; jump if error
SUBST10	CALL	CRLF			; start	on new line
	CALL	PADDR			; print	address
	CALL	SPACE2			; space
	CALL	PDATA			; data
	CALL	SPACE1			; space
	CALL	GARGNSP			; user input, no leading spaces
	JR	Z,SUBST20		; jump if none
	LD	DE,(ARGV0)		; get address in pointer
	LD	A,L			; get new data
	LD	(DE),A			; move it
SUBST20	JR	C,SUBST30		; end if CR pressed
	LD	HL,(ARGV0)		; inc address pointer
	INC	HL
	LD	(ARGV0),HL
	JR	SUBST10
SUBST30	CALL	CRLF
	RET

TEST	; test memory
	; T <start> <stop>
	CALL	SPACE1
	CALL	CARG			; get args
	CALL	CRLF			; new line
	LD	A,(ARGC)		; get count
	CP	2			; test for 2
	JP	NZ,ARGERR		; error	if not
	CALL	V01GT			; see if 2nd > 1st
	JP	C,ARGERR		; jump if so
	INC	HL			; inc count by one
	LD	(ARGV2),HL		; save at arg2
	LD	HL,0			; zero HL
	LD	(ARGV3),HL		; save pass ctr	at arg3
TEST10	LD	HL,(ARGV0)		; get start
	LD	BC,(ARGV2)		; get length
	LD	E,0FFH			; get new data (0xff)
	LD	A,E
	LD	(MISC0),A		; and put to old data
	CALL	MEMLD			; load the memory
	LD	E,0			; zero E
	LD	D,0FFH			; old in D
	LD	HL,(ARGV0)		; get start
	LD	BC,(ARGV2)		; get length
	CALL	MEMRWR			; read,	write, and read
	LD	HL,MISC0		; pt to	old data
	XOR	A			; zero A
	LD	(HL),A			; save old data
	INC	HL			; inc ptr to new data
	LD	A,1			; get new data
	LD	(HL),A			; save it
	XOR	A			; zero A
	INC	HL			; pt to	loop ctr
	LD	(HL),A			; save it
TEST20	LD	HL,MISC0		; pt to	old data
	LD	D,(HL)			; get old data
	INC	HL			; pt to	new
	LD	E,(HL)			; get new
	LD	HL,(ARGV0)		; get start
	LD	BC,(ARGV2)		; get count
	CALL	MEMWLK			; walk the bits	once
	LD	HL,MISC2		; pt to	loop ctr
	INC	(HL)			; inc it
	LD	A,(HL)			; get it
	CP	8			; see if ovf
	JR	NZ,TEST20		; skip if not
	LD	D,80H			; get last old data
	LD	E,0			; data to leave	it as
	LD	BC,(ARGV2)		; count
	LD	HL,(ARGV0)		; start
	CALL	MEMRWR			; load and test	for all	zero
	LD	HL,(ARGV3)		; get the pass counter
	INC	HL			; inc it
	LD	(ARGV3),HL		; save it
	PUSH	HL			; and on stack
	LD	HL,MPSMSG		; pt to	pass message
	CALL	PUTS			; put the string
	POP	HL			; recover pass ctr
	CALL	PHL			; print	it
	CALL	CRLF			; and a	new line
	CALL	RBRDY			; see if break wanted
	JR	NC,TEST10		; continue till	data ready
	CALL	GETCHAR			; get the char and dump	it
	RET

UPPOW	;  power on vector; set vector to VALUE; make check OK
	;  usage: u value
	CALL	SPACE1			; space
	CALL	CARG			; collect arguments
	LD	A,(ARGC)		; get number of args
	CP	1			; see if correct
	JP	NZ,ARGERR		; jump if wrong	number of args
	CALL	CRLF			; new line
	LD	HL,(ARGV0)		; get value
	LD	(POVEC),HL		; save at vector
	LD	A,H			; get H
	CPL				; complement for check
	LD	H,A			; restore
	LD	A,L			; get L
	CPL				; complement for check
	LD	L,A			; restore
	LD	(POVECCK),HL		; save at check location
	RET				; all set for power on test

VERIFY	;  verify that data from BEGIN and END is same begining	at THERE
	;  usage: v begin end there
	CALL	SPACE1			; space
	CALL	CARG			; collect arguments
	LD	A,(ARGC)
	CP	3
	JP	NZ,ARGERR		; jump if wrong	number of args
	CALL	CRLF			; new line
	LD	BC,(ARGV1)		; get END ptr
	INC	BC			; inc it
	LD	HL,(ARGV0)		; get BEGIN ptr
	LD	DE,(ARGV2)		; get THERE ptr
VERIF10	LD	A,(DE)			; get THERE
	CP	(HL)			; see if same as source
	JR	NZ,VERIF20		; fail!
	INC	HL			; inc source ptr
	INC	DE			; inc there ptr
	OR	A			; CY = 0
	PUSH	HL			; save HL
	SBC	HL,BC			; get the difference
	POP	HL			; restore HL
	JR	NZ,VERIF10		; do till done
	RET
VERIF20	PUSH	AF			; save actual
	LD	A,(HL)			; get expected
	PUSH	AF			; save expected
	EX	DE,HL			; HL gets ptr to THERE
	POP	DE			; D gets expected
	POP	AF			; A gets actual
	CALL	MEMER1			; print	as tho memory error
	CALL	CRLF			; newline
	RET

XAM	;  examine and modify registers
	;  to see all standard registers: x
	;  to see a specific prime register and	modify:	x'~
	;  to see a specific register and modify: x'~
	;  where ~ denotes register name
	CALL	GETUCHE			; get a	register
	CP	ACR
	JP	Z,DCPUR			; jump to dump if cr
	CP	AAPOS
	JR	Z,XAM10			; jump if primes wanted
	LD	HL,XNLT-1		; point	to end of non prime lables
	LD	BC,XNLT-XNL		; get count
	CPDR				; find it
	JP	NZ,ERR			; jump if not found
	LD	E,1			; E is # of bytes
	CP	'S'
	CALL	Z,INCE			; 2 if SP
	CP	'P'
	CALL	Z,INCE			; 2 if PC
	CP	'X'
	CALL	Z,INCE			; 2 if IX
	CP	'Y'
	CALL	Z,INCE			; 2 if IY
	LD	HL,XNM			; point	to loc table
	JR	XAM20			; act like substitute cmd
XAM10	CALL	GETUCHE			; get reg name (primes)
	LD	HL,XPLT-1		; point	to end of prime	lables
	LD	BC,XPLT-XPL		; get count
	CPDR				; find it
	JP	NZ,ERR			; jump if not found
	LD	E,1			; E is number of bytes
	LD	HL,XPM			; point	to loc table
XAM20	ADD	HL,BC			; add index
	CALL	HLATHL			; L gets offset	from REGBAS
	LD	H,0			; zero H
	LD	BC,REGBAS		; point	to REGBAS
	ADD	HL,BC			; add to REGBAS
	PUSH	HL			; save address of memory
	CALL	SPACE1			; space	1 char
	CALL	PEQUAL			; print	=
	LD	A,E			; get size of reg
	CP	1
	JR	Z,XAM25			; jump if 1
	INC	HL			; point	to MSB
	CALL	PDATA			; print
	DEC	HL			; restore HL
	DEC	HL			; point	to LSB
XAM25	CALL	PDATA			; print	data
	CALL	SPACE1			; and another space
	CALL	GARG			; get an argument
	PUSH	HL			; save response	on stack
	POP	BC			; put it in BC
	POP	HL			; and the address in HL
	JR	Z,XAM30			; end if no entry
	LD	(HL),C			; save arg in REG memory
	DEC	E			; test E
	JR	Z,XAM30			; end if only one byte
	INC	HL			; point	to next	loc
	LD	(HL),B			; move other byte
XAM30	CALL	CRLF			; finish with newline
	RET				; thats	all

ZNEXT	;  do next instruction and display registers, but don't
	;  break within a CALL
	;  usage: z
	LD	HL,(PLLOC)		; HL gets user PC
	LD	A,(HL)			; get op code
	CP	0CDH			; see if CAL
	JP	Z,TN3			; jump if so
	AND	0C7H			; ignore bits 3, 4, and 5
	CP	0C4H			; see if call of any flavor
	JP	Z,TN3			; jump if so
	JP	NEXT			; can't be CALL so jump

